glibmm 2.56.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gio::SocketService Class Reference
Portable Network I/O Functionality

Make it easy to implement a network service. More...

`#include <giomm/socketservice.h>`

Inheritance diagram for Gio::SocketService:
[legend]

## Public Member Functions
| SocketService (SocketService&& src) noexcept
SocketService& | operator= (SocketService&& src) noexcept
| ~SocketService () noexcept override
GSocketService* | gobj ()
| Provides access to the underlying C GObject. More...
const GSocketService* | gobj () const
| Provides access to the underlying C GObject. More...
GSocketService* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | start ()
| Restarts the service, i.e. start accepting connections from the added sockets when the mainloop runs. More...
void | stop ()
| Stops the service, i.e. stops accepting connections from the added sockets when the mainloop runs. More...
bool | is_active ()
| Check whether the service is active or not. More...
Glib::SignalProxy< bool, const Glib::RefPtr< SocketConnection >&, const Glib::RefPtr< Glib::Object >&> | signal_incoming ()
Glib::PropertyProxy< bool > | property_active ()
| Whether the service is currently accepting connections. More...
Glib::PropertyProxy_ReadOnly< bool > | property_active () const
| Whether the service is currently accepting connections. More...
Public Member Functions inherited from Gio::SocketListener
| SocketListener (SocketListener&& src) noexcept
SocketListener& | operator= (SocketListener&& src) noexcept
| ~SocketListener () noexcept override
GSocketListener* | gobj ()
| Provides access to the underlying C GObject. More...
const GSocketListener* | gobj () const
| Provides access to the underlying C GObject. More...
GSocketListener* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
void | set_backlog (int listen_backlog)
| Sets the listen backlog on the sockets in the listener. More...
bool | add_socket (const Glib::RefPtr< Socket >& socket, const Glib::RefPtr< Glib::Object >& source_object)
| Adds socket to the set of sockets that we try to accept new clients from. More...
bool | add_socket (const Glib::RefPtr< Socket >& socket)
| Adds socket to the set of sockets that we try to accept new clients from. More...
bool | add_address (const Glib::RefPtr< SocketAddress >& address, SocketType type, SocketProtocol protocol, const Glib::RefPtr< Glib::Object >& source_object, Glib::RefPtr< SocketAddress >& effective_address)
| Creates a socket of type type and protocol protocol, binds it to address and adds it to the set of sockets we're accepting sockets from. More...
bool | add_address (const Glib::RefPtr< SocketAddress >& address, SocketType type, SocketProtocol protocol, Glib::RefPtr< SocketAddress >& effective_address)
| Creates a socket of type type and protocol protocol, binds it to address and adds it to the set of sockets we're accepting sockets from. More...
bool | add_inet_port (guint16 port, const Glib::RefPtr< Glib::Object >& source_object)
| Helper function for g_socket_listener_add_address() that creates a TCP/IP socket listening on IPv4 and IPv6 (if supported) on the specified port on all interfaces. More...
bool | add_inet_port (guint16 port)
| Helper function for g_socket_listener_add_address() that creates a TCP/IP socket listening on IPv4 and IPv6 (if supported) on the specified port on all interfaces. More...
guint16 | add_any_inet_port (const Glib::RefPtr< Glib::Object >& source_object)
| Listens for TCP connections on any available port number for both IPv6 and IPv4 (if each is available). More...
guint16 | add_any_inet_port ()
| Listens for TCP connections on any available port number for both IPv6 and IPv4 (if each is available). More...
Glib::RefPtr< Socket > | accept_socket (Glib::RefPtr< Glib::Object >& source_object, const Glib::RefPtr< Cancellable >& cancellable)
| Blocks waiting for a client to connect to any of the sockets added to the listener. More...
Glib::RefPtr< Socket > | accept_socket (Glib::RefPtr< Glib::Object >& source_object)
| Blocks waiting for a client to connect to any of the sockets added to the listener. More...
Glib::RefPtr< Socket > | accept_socket (const Glib::RefPtr< Cancellable >& cancellable)
| Blocks waiting for a client to connect to any of the sockets added to the listener. More...
Glib::RefPtr< Socket > | accept_socket ()
| Blocks waiting for a client to connect to any of the sockets added to the listener. More...
void | accept_socket_async (const Glib::RefPtr< Cancellable >& cancellable, const SlotAsyncReady& slot)
| This is the asynchronous version of g_socket_listener_accept_socket(). More...
void | accept_socket_async (const SlotAsyncReady& slot)
| This is the asynchronous version of g_socket_listener_accept_socket(). More...
Glib::RefPtr< Socket > | accept_socket_finish (const Glib::RefPtr< AsyncResult >& result, Glib::RefPtr< Glib::Object >& source_object)
| Finishes an async accept operation. More...
Glib::RefPtr< Socket > | accept_socket_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes an async accept operation. More...
Glib::RefPtr< SocketConnection > | accept (Glib::RefPtr< Object >& source_object, const Glib::RefPtr< Cancellable >& cancellable)
| Blocks waiting for a client to connect to any of the sockets added to the listener. More...
Glib::RefPtr< SocketConnection > | accept (Glib::RefPtr< Object >& source_object)
| Blocks waiting for a client to connect to any of the sockets added to the listener. More...
Glib::RefPtr< SocketConnection > | accept (const Glib::RefPtr< Cancellable >& cancellable)
| Blocks waiting for a client to connect to any of the sockets added to the listener. More...
Glib::RefPtr< SocketConnection > | accept ()
| Blocks waiting for a client to connect to any of the sockets added to the listener. More...
void | accept_async (const SlotAsyncReady& slot)
| This is the asynchronous version of g_socket_listener_accept(). More...
void | accept_async (const Glib::RefPtr< Cancellable >& cancellable, const SlotAsyncReady& slot)
| This is the asynchronous version of g_socket_listener_accept(). More...
Glib::RefPtr< SocketConnection > | accept_finish (const Glib::RefPtr< AsyncResult >& result, Glib::RefPtr< Glib::Object >& source_object)
| Finishes an async accept operation. More...
Glib::RefPtr< SocketConnection > | accept_finish (const Glib::RefPtr< AsyncResult >& result)
| Finishes an async accept operation. More...
void | close ()
| Closes all the sockets in the listener. More...
Glib::PropertyProxy< int > | property_listen_backlog ()
| outstanding connections in the listen queue. More...
Glib::PropertyProxy_ReadOnly< int > | property_listen_backlog () const
| outstanding connections in the listen queue. More...
Public Member Functions inherited from Glib::Object
| Object (const Object&)=delete
Object& | operator= (const Object&)=delete
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase&)=delete
ObjectBase& | operator= (const ObjectBase&)=delete
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | connect_property_changed (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< SocketService > | create ()
Static Public Member Functions inherited from Gio::SocketListener
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< SocketListener > | create ()

## Protected Member Functions
| SocketService ()
virtual bool | on_incoming (const Glib::RefPtr< SocketConnection >& connection, const Glib::RefPtr< Glib::Object >& source_object)
| This is a default handler for the signal signal_incoming(). More...
Protected Member Functions inherited from Gio::SocketListener
| SocketListener ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase&& src) noexcept
ObjectBase& | operator= (ObjectBase&& src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject* castitem)
void | initialize_move (GObject* castitem, Glib::ObjectBase* previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::SocketService > | wrap (GSocketService* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gio::SocketListener
Glib::RefPtr< Gio::SocketListener > | wrap (GSocketListener* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

Make it easy to implement a network service.

See also
  ThreadedSocketService, SocketListener.

A SocketService is an object that represents a service that is provided to the network or over local sockets. When a new connection is made to the service signal_incoming() is emitted.

A SocketService is a subclass of SocketListener and you need to add the addresses you want to accept connections on with the SocketListener APIs.

There are two options for implementing a network service based on SocketService. The first is to create the service using create() and to connect to signal_incoming(). The second is to subclass SocketService and override the default signal handler implementation, on_incoming().

In either case, the handler must immediately return, or else it will block additional incoming connections from being serviced. If you are interested in writing connection handlers that contain blocking code then see ThreadedSocketService.

The socket service runs on the main loop of the thread-default context of the thread it is created in, and is not threadsafe in general. However, the calls to start and stop the service are threadsafe so these can be used from threads that handle incoming clients.

Since glibmm 2.24:

## Constructor & Destructor Documentation

## ◆ SocketService() [1/2]

Gio::SocketService::SocketService | ( | SocketService&& | src | ) |
| noexcept

## ◆ ~SocketService()

Gio::SocketService::~SocketService | ( |  | ) |
| override noexcept

## ◆ SocketService() [2/2]

Gio::SocketService::SocketService | ( |  | ) |
| protected

## Member Function Documentation

## ◆ create()

static Glib::RefPtr<SocketService> Gio::SocketService::create | ( |  | ) |
| static

## ◆ get_type()

static GType Gio::SocketService::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GSocketService* Gio::SocketService::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GSocketService* Gio::SocketService::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GSocketService* Gio::SocketService::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ is_active()

bool Gio::SocketService::is_active | ( |  | ) |

Check whether the service is active or not.

An active service will accept new clients that connect, while a non-active service will let connecting clients queue up until the service is started.

Since glibmm 2.22:

Returns
  `true` if the service is active, `false` otherwise.

## ◆ on_incoming()

virtual bool Gio::SocketService::on_incoming | ( | const Glib::RefPtr< SocketConnection >& | connection,
|  | const Glib::RefPtr< Glib::Object >& | source_object
| ) |  |
| protected virtual

This is a default handler for the signal signal_incoming().

## ◆ operator=()

SocketService& Gio::SocketService::operator= | ( | SocketService&& | src | ) |
| noexcept

## ◆ property_active() [1/2]

Glib::PropertyProxy< bool > Gio::SocketService::property_active | ( |  | ) |

Whether the service is currently accepting connections.

Since glibmm 2.46:

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_active() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gio::SocketService::property_active | ( |  | ) | const

Whether the service is currently accepting connections.

Since glibmm 2.46:

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ signal_incoming()

Glib::SignalProxy< bool,const Glib::RefPtr<SocketConnection>&,const Glib::RefPtr<Glib::Object>& > Gio::SocketService::signal_incoming | ( |  | ) |

Slot Prototype:
  `bool on_my_incoming(const Glib::RefPtr<SocketConnection>& connection, const Glib::RefPtr<Glib::Object>& source_object)`

Flags: Run Last

The signal_incoming() signal is emitted when a new incoming connection to service needs to be handled. The handler must initiate the handling of connection, but may not block; in essence, asynchronous operations must be used.

connection will be unreffed once the signal handler returns, so you need to ref it yourself if you are planning to use it.

Since glibmm 2.22:

Parameters

  connection | A new SocketConnection object.
  source_object | The source_object passed to g_socket_listener_add_address().

Returns
  `true` to stop other handlers from being called.

## ◆ start()

void Gio::SocketService::start | ( |  | ) |

Restarts the service, i.e. start accepting connections from the added sockets when the mainloop runs.

This only needs to be called after the service has been stopped from g_socket_service_stop().

This call is thread-safe, so it may be called from a thread handling an incoming client request.

Since glibmm 2.22:

## ◆ stop()

void Gio::SocketService::stop | ( |  | ) |

Stops the service, i.e. stops accepting connections from the added sockets when the mainloop runs.

This call is thread-safe, so it may be called from a thread handling an incoming client request.

Note that this only stops accepting new connections; it does not close the listening sockets, and you can call g_socket_service_start() again later to begin listening again. To close the listening sockets, call g_socket_listener_close(). (This will happen automatically when the SocketService is finalized.)

This must be called before calling g_socket_listener_close() as the socket service will start accepting connections immediately when a new socket is added.

Since glibmm 2.22:

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gio::SocketService > wrap | ( | GSocketService * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.